Index: /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionEleven.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionEleven.cs	(revision 15474)
+++ /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionEleven.cs	(revision 15475)
@@ -37,6 +37,7 @@
           + "Function: f(x, y) = xy + sin((x - 1)(y - 1))" + Environment.NewLine
           + "range(train): 20 Training cases x,y = rnd(-3, 3)" + Environment.NewLine
-          + "range(test): x,y = [-3:0.01:3]" + Environment.NewLine
-          + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)";
+          + "range(test): x,y = [-3:0.1:3]" + Environment.NewLine
+          + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)" + Environment.NewLine
+          + "Comments: Reduced test set compared to original publication!";
       }
     }
@@ -47,5 +48,5 @@
     protected override int TrainingPartitionEnd { get { return 20; } }
     protected override int TestPartitionStart { get { return 20; } }
-    protected override int TestPartitionEnd { get { return 20 + (601 * 601); } }
+    protected override int TestPartitionEnd { get { return 20 + (61 * 61); } }
     public int Seed { get; private set; }
 
@@ -57,5 +58,5 @@
     protected override List<List<double>> GenerateValues() {
       List<List<double>> data = new List<List<double>>();
-      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.01m).Select(v => (double)v).ToList();
+      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.1m).Select(v => (double)v).ToList();
       List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
 
Index: /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFifteen.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFifteen.cs	(revision 15474)
+++ /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFifteen.cs	(revision 15475)
@@ -36,6 +36,7 @@
         + "Function: f(x, y) = x³ / 5 + y³ / 2 - y - x" + Environment.NewLine
         + "range(train): 20 Training cases x,y = rnd(-3, 3)" + Environment.NewLine
-        + "range(test): x,y = [-3:0.01:3]" + Environment.NewLine
-        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)";
+        + "range(test): x,y = [-3:0.1:3]" + Environment.NewLine
+        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)" + Environment.NewLine
+        + "Comments: Reduced test set compared to original publication!";
       }
     }
@@ -46,5 +47,5 @@
     protected override int TrainingPartitionEnd { get { return 20; } }
     protected override int TestPartitionStart { get { return 20; } }
-    protected override int TestPartitionEnd { get { return 20 + (601 * 601); } }
+    protected override int TestPartitionEnd { get { return 20 + (61 * 61); } }
     public int Seed { get; private set; }
 
@@ -56,5 +57,5 @@
     protected override List<List<double>> GenerateValues() {
       List<List<double>> data = new List<List<double>>();
-      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.01m).Select(v => (double)v).ToList();
+      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.1m).Select(v => (double)v).ToList();
       List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
 
Index: /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFourteen.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFourteen.cs	(revision 15474)
+++ /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionFourteen.cs	(revision 15475)
@@ -36,6 +36,7 @@
         + "Function: f(x, y) = 8 / (2 + x² + y²)" + Environment.NewLine
         + "range(train): 20 Train cases x,y = rnd(-3, 3)" + Environment.NewLine
-        + "range(test): x,y = [-3:0.01:3]" + Environment.NewLine
-        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)";
+        + "range(test): x,y = [-3:0.1:3]" + Environment.NewLine
+        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)" + Environment.NewLine
+        + "Comments: Reduced test set compared to original publication!";
       }
     }
@@ -46,5 +47,5 @@
     protected override int TrainingPartitionEnd { get { return 20; } }
     protected override int TestPartitionStart { get { return 20; } }
-    protected override int TestPartitionEnd { get { return 20 + (601 * 601); } }
+    protected override int TestPartitionEnd { get { return 20 + (61 * 61); } }
     public int Seed { get; private set; }
 
@@ -58,5 +59,5 @@
     protected override List<List<double>> GenerateValues() {
       List<List<double>> data = new List<List<double>>();
-      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.01m).Select(v => (double)v).ToList();
+      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.1m).Select(v => (double)v).ToList();
       List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
 
Index: /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionThirteen.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionThirteen.cs	(revision 15474)
+++ /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionThirteen.cs	(revision 15475)
@@ -36,6 +36,7 @@
         + "Function: f(x, y) = 6 * sin(x) * cos(y)" + Environment.NewLine
         + "range(train): 20 Train cases x,y = rnd(-3, 3)" + Environment.NewLine
-        + "range(test): x,y = [-3:0.01:3]" + Environment.NewLine
-        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)";
+        + "range(test): x,y = [-3:0.1:3]" + Environment.NewLine
+        + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)" + Environment.NewLine
+        + "Comments: Reduced test set compared to original publication!";
       }
     }
@@ -46,5 +47,5 @@
     protected override int TrainingPartitionEnd { get { return 20; } }
     protected override int TestPartitionStart { get { return 20; } }
-    protected override int TestPartitionEnd { get { return 20 + (601 * 601); } }
+    protected override int TestPartitionEnd { get { return 20 + (61 * 61); } }
     public int Seed { get; private set; }
 
@@ -56,5 +57,5 @@
     protected override List<List<double>> GenerateValues() {
       List<List<double>> data = new List<List<double>>();
-      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.01m).Select(v => (double)v).ToList();
+      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.1m).Select(v => (double)v).ToList();
       List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
 
Index: /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionTwelve.cs
===================================================================
--- /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionTwelve.cs	(revision 15474)
+++ /stable/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/Keijzer/KeijzerFunctionTwelve.cs	(revision 15475)
@@ -36,6 +36,7 @@
                + "Function: f(x, y) = x^4 - x³ + y² / 2 - y" + Environment.NewLine
                + "range(train): 20 Training cases x,y = rnd(-3, 3)" + Environment.NewLine
-               + "range(test): x,y = [-3:0.01:3]" + Environment.NewLine
-               + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)";
+               + "range(test): x,y = [-3:0.1:3]" + Environment.NewLine
+               + "Function Set: x + y, x * y, 1/x, -x, sqrt(x)" + Environment.NewLine
+               + "Comments: Reduced test set compared to original publication!";
       }
     }
@@ -46,5 +47,5 @@
     protected override int TrainingPartitionEnd { get { return 20; } }
     protected override int TestPartitionStart { get { return 20; } }
-    protected override int TestPartitionEnd { get { return 20 + (601 * 601); } }
+    protected override int TestPartitionEnd { get { return 20 + (61 * 61); } }
     public int Seed { get; private set; }
 
@@ -56,5 +57,5 @@
     protected override List<List<double>> GenerateValues() {
       List<List<double>> data = new List<List<double>>();
-      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.01m).Select(v => (double)v).ToList();
+      List<double> oneVariableTestData = SequenceGenerator.GenerateSteps(-3, 3, 0.1m).Select(v => (double)v).ToList();
       List<List<double>> testData = new List<List<double>>() { oneVariableTestData, oneVariableTestData };
 